<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/25/2003 *
 * ===============                              Last change: 11/24/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : header.php                                       *
 * -------------------------------------------------------------------- *
 * Short description : Outputs header HTML code, will not when frameset *
 *           is active                                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Gibt nur dann HTML-Code fuer den Kopf-Bereich    *
 *           aus, wenn Frameset nicht aktiv ist                         *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}

if (defined('frameset_active')) {
	// Initialize variables
	$header = ""; $FOOTER = "";
	if (empty($GLOBALS['what'])) $GLOBALS['what'] = "";
	if (($header != "1") && ($header != "2")) {
		// If not in CSS mode generate the header
		if (($CSS != "1")) {
			// Generate header
			$TITLE = "";

			// Add title decorations? (left)
			if ((!empty($CONFIG)) && (isset($link)) && (isset($db))) {
				if (($CONFIG['title_decoration'] == "Y") && (trim(!empty($CONFIG['title_left'])))) $TITLE .= trim($CONFIG['title_left'])." ";
				$TITLE .= MAIN_TITLE;

				// Add title of module? (middle decoration will also be added!)
				if (($CONFIG['title_mod_show'] == "Y") || ((empty($GLOBALS['what'])) && (empty($GLOBALS['action']))) || ($GLOBALS['module'] == "admin")) $TITLE .= " ".trim($CONFIG['title_middle'])." ".ADD_MODULE_TITLE($GLOBALS['module']);

				// Add title from what file
				$MODE = "";
				if ($GLOBALS['module'] == "login") $MODE = "member";
				 elseif ($GLOBALS['module'] == "index") $MODE = "guest";
				if ((!empty($MODE)) && ($CONFIG['title_what_show'] == "Y")) $TITLE .= " ".trim($CONFIG['title_middle'])." ".GET_MOD_DESCR($MODE, $GLOBALS['what']);

				// Add title decorations? (right)
				if (($CONFIG['title_decoration'] == "Y") && (!empty($CONFIG['title_right']))) $TITLE .= " ".trim($CONFIG['title_right']);

				// Remember title in constant for the template
				define('__PAGE_TITLE', html_entity_decode($TITLE));
			} elseif ((!mxchange_installed) || (!admin_registered)) {
				// Load language file because it was missing in installation finalizer step... *sigh*
				require_once(sprintf("%sinc/language/install_%s.php",
					PATH,
					GET_LANGUAGE()
				));

				// Installation mode
				define('__PAGE_TITLE', INSTALLATION_OF_MXCHANGE);
			} else {
				// Configuration not found!
				define('__PAGE_TITLE', NO_CONFIG_FOUND_TITLE);
				ADD_FATAL(NO_CONFIG_FOUND);
			}

			// Save some little memory
			unset($TITLE);

			// Output page header code
			LOAD_TEMPLATE("page_header");

			// Include meta data here
			LOAD_TEMPLATE("metadata");

			// Add meta description to header
			if ((mxchange_installed) && (admin_registered) && ($GLOBALS['module'] != "admin") && ($GLOBALS['module'] != "login") && (isset($db)) && (isset($link))) {
				// Add meta description not in admin and login module and when the script is installed
				META_DESCRIPTION($GLOBALS['module'], $GLOBALS['what']);
			}

			// Include more header data here
			LOAD_TEMPLATE("header");

			// Include stylesheet
			include (PATH."inc/stylesheet.php");
		}

		// Closing HEAD tag
		if ($CSS != "1") OUTPUT_HTML ("</HEAD>\n");
		$header = 1;
	}

	// Set unsetted variables
	if (empty($_GET['frame'])) $_GET['frame'] = "";

	// Load body or not
	if (((!frameset_active) && ($GLOBALS['module'] != "frametester")) || (($header == "1") && ($GLOBALS['module'] == "frametester") && (!empty($_GET['frame']))) && ($CSS != "1")) {
		// Is the header sent and the script is not the mail confirmation script and not a CSS?
		if (($header == "1") && (basename($_SERVER['PHP_SELF']) != "mailid.php") && ($CSS != "1")) {
			// Add BODY tag
			LOAD_TEMPLATE("page_body");
  			$header = 2;
  		}
	}
} else {
	// Something is missing
	die ("<STRONG>Fatal error:</STRONG> You have to define <STRONG>frameset_active</STRONG>!");
}
//
?>
