<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/16/2003 *
 * ===============                              Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : mysql-connect.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Connects to your database                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Verbindet zu Ihrer Datenbank                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4)."/security.php";
	require($INC);
}

// CFG: DEBUG-SQL (if enabled and DEBUG_MODE is enabled all SQL queries will be logged to debug.log)
define('DEBUG_SQL', false);

// Load library
require_once(PATH."inc/db/lib.php");

// Check if the user setups his MySQL stuff...
if ((empty($MySQL['login'])) && (!mxchange_installing) && (!isset($_GET['installing'])) && (mxchange_installed))
{
	// No login entered and outside installation mode
	echo "<STRONG>".LANG_WARNING.":</STRONG> ";
	if (mxchange_installed)
	{
		// You have changed my configuration file!
		die(DIE_CONFIG_CHANGED_YOU);
	}
	 else
	{
		// Please run the installation script (maybe again)
		die(DIE_RUN_INSTALL_MYSQL);
	}
}
 elseif ((!mxchange_installing) && (!isset($_GET['installing'])) && (empty($MySQL['password'])) && (warn_no_pass))
{
	// No database password entered!!!
	echo "<STRONG>".LANG_WARNING.":</STRONG> ".WARN_NULL_PASSWORD;
}

// Check if this file is writeable or read-only and warn the user
if ((!mxchange_installing) && (mxchange_installed))
{
	// Check for write-permission for config.php and inc directory
	if (empty($GLOBALS['module'])) $GLOBALS['module'] = "index";
	if (($GLOBALS['module'] != "admin") && (admin_registered))
	{
		if (is_INCWritable("config"))     ADD_FATAL(FATAL_CONFIG_WRITABLE);
		if (is_INCWritable("dummy"))      ADD_FATAL(FATAL_INC_WRITABLE);
	}

	// Init configuration arrays
	$CONFIG = array(
		'code_length' => 0
	);
	$EXT_CSS_FILES = array();

	// Load general stuff, like...
	require_once(PATH."inc/extensions.php"); // Extension management
	require_once(PATH."inc/functions.php");  // Non-database functions
	require_once(PATH."inc/databases.php");     // Several hard-coded databases (arrays, constants)

	if ((!empty($MySQL['host'])) && (!empty($MySQL['login'])) && (!empty($MySQL['password'])) && (!empty($MySQL['dbase'])))
	{
		// Connect to DB
		$link = SQL_CONNECT($MySQL['host'], $MySQL['login'], $MySQL['password'], __FILE__, __LINE__);
		if ($link)
		{
			$db = SQL_SELECT_DB($MySQL['dbase'], $link, __FILE__, __LINE__);
			if ($db)
			{
				// Load configuration stuff    0            1                2          3              4                    5              6            7          8            9          10             11          12          13            14             15              16           17             18            19              20          21             22              23                 24                 25            26           27          28           29             30                 31              32           33            34
				$result = SQL_QUERY("SELECT pass_len, points_register, points_ref, least_cats, check_double_email, check_double_pass, admin_notify, url_tlock, test_text, max_tlength, test_subj, autosend_active, max_send, url_blacklist, auto_purge, auto_purge_active, last_update, unconfirmed, profile_lock, online_timeout, mad_timestamp, mad_count, profile_update, send_prof_update, resend_profile_update, code_length, patch_level, patch_ctime, guest_stats, ref_payout, activate_xchange, order_multi_page, display_refid, ip_timeout, allow_direct_pay, config FROM "._MYSQL_PREFIX."_config WHERE config='0' LIMIT 1", __FILE__, __LINE__);

				if (SQL_NUMROWS($result) == 1)
				{
					// Load data when previous SQL query did not fail
					if ($result) $DUMMY = SQL_FETCHROW($result);

					// We copy the fetched data to the CONFIG array (or can you remember which number is for which config value??? ;-) )
					$CONFIG = array(
						'pass_len'        =>  $DUMMY[0], // Minimum password length
						'points_register' =>  $DUMMY[1], // How many points the new member gets on registration
						'points_ref'      =>  $DUMMY[2], // How many points a members gets on direct referral
						'least_cats'      =>  $DUMMY[3], // Minimum number of categories to be selected
						'dbl_email'       =>  $DUMMY[4], // Shall we check if the email address is already in out database?
						'dbl_pass'        =>  $DUMMY[5], // Shall we - silencly - check if another user is using the same password?
						'admin_notify'    =>  $DUMMY[6], // Shall I notify the admin if a member has changed his profile?
						'url_tlock'       =>  $DUMMY[7], // Time in seconds to lock same ordered URL
						'test_text'       =>  $DUMMY[8], // Shall I test the text against URLs?
						'max_tlength'     =>  $DUMMY[9], // How long shall the ordered text be?
						'test_subj'       => $DUMMY[10], // Shall I test the subject against URLs?
						'autosend_active' => $DUMMY[11], // Active / Deactive auto-send feature? (currently disabled feature)
						'max_send'        => $DUMMY[12], // How many shall I send in one time from the pool?
						'url_blacklist'   => $DUMMY[13], // Shall I enable or disable the URL black-list feature?
						'auto_purge'      => $DUMMY[14], // How many days shall mails stay in stats table? (disabled!)
						'ap_active'       => $DUMMY[15], // Shall auto-purge be enabled or disbaled? (disabled!)
						'last_update'     => $DUMMY[16], // Last update when reset on database was
						'unconfirmed'     => $DUMMY[17], // How many unconfirmed mails shall I allow to order new mails?
						'profile_lock'    => $DUMMY[18], // Time in seconds to keep a member's profile write-protected after he changes something
						'online_timeout'  => $DUMMY[19], // Session expiration in online list
						'profile_update'  => $DUMMY[22], // How many seconds between profile update notification?
						'send_update'     => $DUMMY[23], // Shall I send profile update notifications to your members?
						'prof_reupdate'   => $DUMMY[24], // Seconds between re-notifications for profile update?
						'code_length'     => $DUMMY[25], // Length of the code the member has to re-type
						'patch_level'     => $DUMMY[26], // Installed patch level in database
						'patch_ctime'     => $DUMMY[27], // Latest patch file
						'gstats_mode'     => $DUMMY[28], // Guest statistics mode: About your members, module clicks or inactive
						'ref_payout'      => $DUMMY[29], // After how many confirmed mails shall the referral bonus be paid? (0 = disable feature)
						'activate_system' => $DUMMY[30], // Automatic activation of your exchange after x days (0 = disable feature)
						'order_multi'     => $DUMMY[31], // Shall I activate multiple pages in order form? This will enable sending by ZIP code
						'display_refid'   => $DUMMY[32], // Shall I display the refid in registration form or not?
						'ip_timeout'      => $DUMMY[33], // Timeout for same IP number in registration form
						'direct_pay'      => $DUMMY[34], // Shall I pay "clicked" points directly or not? Not is default.
					);
					unset($DUMMY);

					// Initialize include-file-pool
					$INC_POOL = array();

					// Load more include files
					require_once(PATH."inc/mysql-manager.php"); // Functions which interact with the database

					// Run daily reset
					if ((date("d", $CONFIG['last_update']) != date("d", time()) || (DEBUG_MODE == true)) && (!mxchange_installing) && (mxchange_installed) && (admin_registered) && (!isset($_GET['register'])) && ($CSS != 1))
					{
						// Do daily things in external PHP file but only when script is completely setup
						$INC_POOL[] = PATH."inc/reset/reset_daily.php";

						// Daily reset was run!
						define('__DAILY_RESET', "1");
					}

					// Load all extensions
					require_once(PATH."inc/load_extensions.php");

					// Loading patching system is required here...
					require_once(PATH."inc/patch-system.php");	// Initialize patch system

					// Functions which are related to themes
					require_once(PATH."inc/theme-manager.php");

					// Initialize session management
					require_once(PATH."inc/session.php");

					// Load admin include file if he is admin
					if (IS_ADMIN())
					{
						// Administrative functions
						require_once(PATH."inc/modules/admin/admin-inc.php");
					}

					// Get all values
					if (($CSS != 1) && ($CSS != -1))
					{
						if (empty($GLOBALS['module']))  $GLOBALS['module'] = "empty";
						if (empty($GLOBALS['what']))    $GLOBALS['what']   = GET_WHAT($GLOBALS['module']);
						if (empty($GLOBALS['action']))  $GLOBALS['action'] = GET_ACTION($GLOBALS['module'], $GLOBALS['what']);
					}
					 else
					{
						// Set action/what to empty
						$GLOBALS['action'] = "";
						$GLOBALS['what']   = "";
					}

					// Secure and validate user ID from cookie
					UPDATE_LOGIN_DATA();

					// Get session ID
					if (empty($_COOKIE['PHPSESSID'])) $_COOKIE['PHPSESSID'] = session_id();

					// Update online list
					UPDATE_ONLINE_LIST($_COOKIE['PHPSESSID'], $GLOBALS['module'], $GLOBALS['action'], $GLOBALS['what']);

					// Load theme name
					$CurrTheme = GET_CURR_THEME();

					// Set default 'what' value
					//* DEBUG */ echo "-".$GLOBALS['module']."/".$GLOBALS['what']."-<br />\n";
					if ((empty($GLOBALS['what'])) && (empty($GLOBALS['action'])) && ($CSS != 1) && ($CSS != -1))
					{
						if ($GLOBALS['module'] == "admin")
						{
							// Set 'action' value to 'login' in admin menu
							$GLOBALS['action'] = GET_ACTION($GLOBALS['module'], $GLOBALS['what']);
						}
						 elseif (($GLOBALS['module'] == "index") || ($GLOBALS['module'] == "login"))
						{
							// Set 'what' value to 'welcome' in guest and member menu
							$GLOBALS['what'] = "welcome";
							if (!empty($CONFIG['index_home'])) $GLOBALS['what'] = $CONFIG['index_home'];
						}
						 else
						{
							// Anything else like begging link
							$GLOBALS['what'] = "";
						}
					}

					// Update sending pool
					if (($CSS != "1") && ($CSS != "-1")) require_once(PATH."inc/pool-update.php"); // Sends out mails in configureable steps

					// Load all active extension including language files when not upgrading.
					// Check module for testing and count one click
					$dummy = CHECK_MODULE($GLOBALS['module']);
					if ($dummy == "done") COUNT_MODULE($GLOBALS['module']);
					unset($dummy);
					if ($CONFIG['activate_system'] > 0) ACTIVATE_EXCHANGE();
				}
				 else
				{
					// If you will read following error message you probably need to contact me (webmaster@mxchange.org)
					// and download the sql-upgrades extension from my server. Please ask me which SQL file(s) you need to
					// import *BEFORE* you import them!
					ADD_FATAL(FATAL_CANNOT_LOAD_CONFIG);
				}

				// Free memory
				SQL_FREERESULT($result);
			}
			 else
			{
				// Wrong database?
				ADD_FATAL(WRONG_DB_SELECTED);
			}
		}
		 else
		{
			// No link to database!
			ADD_FATAL(NO_DB_LINK);
			$db = false;
		}
	}
	 else
	{
		// Maybe you forgot to enter your MySQL data?
		ADD_FATAL(MYSQL_DATA_MISSING);
	}
}
 else
{
	///////////////////////////////////////////////////
	// Include neccessary functions for installation //
	///////////////////////////////////////////////////

	// Set CONFIG array
	$CONFIG = array(
		'code_length' => 0
	);

	// Set other missing variables
	$link = false; // No database link by default

	// Include required files
	require_once(PATH."inc/databases.php");
	require_once(PATH."inc/extensions.php");
	require_once(PATH."inc/theme-manager.php");
	require_once(PATH."inc/load_extensions.php");
	require_once(PATH."inc/session.php");

	// Check if we are in installation routine
	$installPhp = basename($_SERVER['PHP_SELF']);
	if (($installPhp != "install.php") && ($CSS != "1") && ($CSS != -1)) {
		// Redirect to the installation system
		LOAD_URL(URL."/install.php");
	}

	// Double-check installation mode
	if ((!mxchange_installed) || (!admin_registered)) {
		// Check for file permissions
		if (!is_INCWritable("config")) {
			ADD_FATAL(CONFIG_IS_WRITE_PROTECTED);
		}
		if (!is_INCWritable("dummy")) {
			ADD_FATAL(DUMMY_IS_WRITE_PROTECTED);
		}
		if (!is_INCWritable(".secret/dummy")) {
			ADD_FATAL(SECRET_IS_WRITE_PROTECTED);
		}
	}
}

// Any fatal messages?
if (!is_array($FATAL)) $FATAL = array();
if (((sizeof($FATAL) > 0) || (!empty($FATAL[0]))) && (mxchange_installed) && (!mxchange_installing) && ($CSS != "1"))
{
	// One or more fatal error(s) occur during connect...
	include (PATH."inc/header.php");
	include (PATH."inc/fatal_errors.php");
	unset($FATAL);
	include (PATH."inc/footer.php");
	exit;
}

//
?>
